/*
 * YouGrabber
 *
 * A lightweight, command line YouTube.com video downloader, made from scratch
 * in ANSI C.
 *
 * Copyright (C) 2006-2007 Quetzy Garcia, <quetzyg@users.sourceforge.net>
 * For news and updates, see <http://yougrabber.sourceforge.net/>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <libgen.h>
#include <glib.h>
#include <locale.h>
#include <ncurses.h>
#include <curl/curl.h>

#ifndef CONFIG_H
  #include "config.h"
#endif

#ifndef DOWNLOAD_H
  #include "download.h"
#endif

#ifndef INTERFACE_H
  #include "interface.h"
#endif

#define _GNU_SOURCE
#define REENTRANT

/* application info */
static const char YG_STRING[] = {"YouGrabber"};
static const char YG_VERSION[] = {"0.29.4"};
static const char YG_AUTHOR[] = {"Quetzy Garcia"};
static const char YG_EMAIL[] = {"quetzyg@users.sourceforge.net"};

/* print a string with the yg info header */
extern void yg_print(char *);

/* configure an easy cURL handle */
extern CURL *yg_handle_config(CURL *, YGC *, FILE *, const char *, char *, int,
  void *, void *, char *);

/* cut a string between two delimiters (returns new alloc'd string) */
extern char *yg_strcut(const char *, const char *, const char *);

/* generate a file name with full path (returns new alloc'd string) */
extern char *yg_filegen(const char *, const char *, const char *);

/* convert a UTF8 string to the current locale (returns new alloc'd string) */
extern char *yg_utf2locale(char *);
