/*
 * YouGrabber
 *
 * A lightweight, command line YouTube.com video downloader, made from scratch
 * in ANSI C.
 *
 * Copyright (C) 2006-2007 Quetzy Garcia, <quetzyg@users.sourceforge.net>
 * For news and updates, see <http://yougrabber.sourceforge.net/>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONFIG_H
  #define CONFIG_H 1
#endif

typedef struct __yg_config YGC;

typedef enum
{
  YG_LOGIN_ERROR_CONNECT,
  YG_LOGIN_ERROR_FAILED,
  YG_LOGIN_OK_SKIPPED,
  YG_LOGIN_OK_CONNECTING,
  YG_LOGIN_OK_LOGGED
} YGStatusLogin;

/* create configuration settings and return pointer */
extern YGC *yg_config_new(void);

/* free configuration resources */
extern void yg_config_free(YGC *);

/* login to youtube */
extern int yg_config_login_perform(YGC *);

/* get youtube login status */
extern int yg_config_login_status(YGC *);

/* get the cookie file */
extern char *yg_config_cookie(YGC *);

/* get yg user agent */
extern char *yg_config_agent(YGC *);

/* get the configuration file */
extern char *yg_config_file(YGC *);

/* get proxy host */
extern char *yg_config_proxy_host(YGC *);

/* get proxy port */
extern long yg_config_proxy_port(YGC *);

/* get proxy type */
extern long yg_config_proxy_type(YGC *);

/* get the proxy credentials (username + password) */
extern const char *yg_config_proxy_credentials(YGC *);

/* get the download directory */
extern const char *yg_config_download_dir(YGC *);
